%-------------------------------------------------------------------
% lecture des donnes d'apprentissage
load pendigits_data.txt -ascii 
X=pendigits_data(:,1:16); % vecteur des observations en entre
Y=pendigits_data(:,17);   % vecteur des observations en sortie

%-------------------------------------------------------------------
% prparation des donnes
X=X/50-1; % les entres sont normes et centres
Y=(Y==3); % les sorties valent 1 pour le chiffre 3, 0 pour les 
          % autres chiffres

%-------------------------------------------------------------------
% Cration du rseau avec ? neurones d'entre, ? neurones cachs 
% et 1 neurone de sortie avec la fonction logistique
net = mlp(?,?, 1, 'logistic');                            

%-------------------------------------------------------------------
% Rglages des options de l'algorithme d'optimisation
options = zeros(1,18); % vecteur nul de taille 18
options(1) = 1;        % affiche l'erreur totale  chaque itration
options(14) = ?;       % nombre maximum d'itrations 

%-------------------------------------------------------------------
% Optimisation avec un algorithme quasi-newton
[net, options, errors] = netopt(net, options, X, Y, 'scg');

%-------------------------------------------------------------------
% Affichage du critre des moindres carrs en fonction des itrations
figure(1);        
semilogy(errors);
xlabel('Itrations');
ylabel('Critre des moindres carrs');
title('Optimisation des poids du rseau');	

%-------------------------------------------------------------------
% Calcul de la valeur finale du critre des moindres carrs pour les 
% donnes d'apprentissage
Crit_data=mlperr(net,X,Y);
disp('--------------------------------------------------');
disp(['Valeur du critre (data) :              ' num2str(Crit_data)]);

%-------------------------------------------------------------------
% Comparaison de la sortie du rseau et des donnes
YR=mlpfwd(net,X)>0.5; % Calcul de la sortie et seuillage  0.5
Nb_detection=sum(and(YR,Y));
Nb_non_detection=sum(Y)-Nb_detection;
Nb_fausse_detection=sum(YR)-Nb_detection;
disp(['Nombre de dtections correctes (data) : ' num2str(Nb_detection)]);
disp(['Nombre de non dtections (data) :       ' num2str(Nb_non_detection)]);
disp(['Nombre de fausses dtections (data) :   ' num2str(Nb_fausse_detection)]);

